Welcome

Copy Handler program is a small tool designed for copy/move files and folders between different storage medias (hard disks, floppy disks, local networks, CD-ROMs and many other).
This help file contains most of the information you would like to know about using Copy Handler.
  • Read the GNU General Public License
  • Read the requirements of this program
  • Installation process
  • How to use ?
  • What's new in the current version
  • Known bugs/issues
  • People who helped in creating this program
  • Contact/support
  • Reporting bugs
!!Attention!!

Author of this program (that is me) do not take any responsibility for any damage produced by this program or its working. If you think, that you might lose something very important to you, and you don't trust this program - simply do not use it. As for me it works fine. (Look at the license for details).


F.A.Q.

Q: Why does the commands (CH) Copy to, (CH) Move to and (CH) Copy/move to special... in the explorer context menu are grayed out ?

A: To make theses options appear active you have to define some shortcuts in the configuration dialog in the section "Shortcuts". These shortcuts defines some frequently used destination locations that would be displayed under the commands mentioned above.

See also: Configuration dialog


Installation

[Exe] | Execute the executable file and proceed with the onscreen infos.
[Zip] | Unzip file to some folder on the hard disk and run program Copy Handler from that folder. If you want to enable shell integration just choose 'Register shell extension dll' from the program menu in system tray.
Upgrade (installing new version on the old one)

[Exe] | Just run the new install file and follow the instructions
[Zip] | Uninstall the old version (look below) and install the new one (look above)
Uninstallation

[Exe] | Run the uninstaller from the folder in which you have installed the program, from the start menu or add/remove programs in control panel and proceed with the infos displayed on screen
[Zip] | #1. With program running choose option 'Unregister shell extension dll' from its menu. #2. Log off or restart your computer. #3. If you see program's icon in taskbar after restart - choose from it's menu option 'Exit' #4. Delete the folder in which you have previously installed Copy Handler
See also: How to use ?, Program's main menu


How to use ?

How to copy something using Copy Handler ?
If you have registered shell extension DLL:
  • Drag some files/folder in explorer by right mouse button, drop it somewhere else and choose one of the options from context menu that begins with (CH)
  • Copy something to clipboard (by selecting some files in explorer and pressing ctrl+C on your keyboard or by choosing 'Copy' command from explorer context menu) and paste it in other location by '(CH) Paste' or '(CH) Paste special...'. If you have turned on the option 'Monitor clipboard' - after the copying something into the clipboard there should be displayed a dialog where you can choose the destination location for the selected files and folders and the type of operation.
  • If you have selected option 'Intercept dragging' and you have rather new system (Windows Me, 2000 or XP) you can also drag&drop files by left mouse button and use standard Windows 'Paste' command or ctrl+V.
If you haven't registered the shell extension:
  • The only way to start copying or moving data is to select 'Enter custom copy parameters...' from program's menu, to fill it with needed data (source files and destination folder) and to accept the entered data with OK button.
See also: Program's requirements, Program's history, Installation


Program requirements

To properly work this program requires:
  • Pentium class or 100% compatible processor (maybe it would work on 386 or 486-class systems, but it has not been tested).
  • Microsoft Windows 95/98/Me/NT4/2000/XP operating system
  • About 1 MB free space on hard disk
  • display with at least 800x600 resolution (program will also run with lower resolutions, but some dialogs wouldn't be fully visible)
  • MFC libraries version 4.2 installed in a system (usually they are shipped with system)
  • Tahoma font installed in a system
See also: License, Program's history


Advanced context menu

Advanced context menu is placed in the status dialog.
  • Change paths... - allows user to change some source paths (ie. when copying files from c:\windows you restart the computer and after it the drive letter from c changed to d you can change the source path from c:\windows to d:\windows). Command opens the replace paths dialog.
See also: Status dialog, Replace paths dialog


Buffer size dialog

This dialog may be displayed through the configuration dialog in 'Buffer' section or through the status dialog.
  • Default - default buffer size. Used when the configuration option 'Use only default buffer' (in section 'Buffer') is set, or when none of the other buffer sizes doesn't match the current situation.
  • For copying inside one disk boundary - Buffer is used when the source files and the destination folder lies on the same physical disk. Size of that buffer is usually bigger than the standard two-disks buffer, because if you copy data in bigger packs you do not burden your hard disk as much as when you use small buffers.
  • For copying between two different disks - The buffer is used when you copy data from one physical hard disk to another one.
  • For copying with CD-ROM use - This buffer size is used when you copy something between CD-ROM and any other storage medium.
  • For copying with network use - This buffer size is used when you copy something from or to the local network.
  • Use only default buffer - when this option is checked, the task(s) will always use the default buffer size ignoring type of source and destination storage medium.
See also: Configuration dialog, Status dialog


Configuration dialog

  • Program - general options concerning the program
    • Clipboard monitoring - specifies whether clipboard should be monitored for new data (if it's enabled then after copying files to clipboard there should appear window to choose destination folder)
    • Scan clipboard every ... [ms] - specify time interval in miliseconds at which the clipboard will be checked (look above)
    • Run program with system - specify whether the program should start with system or not (enabling it will cause some entries to be added to the registry)
    • Shutdown system after copying finishes - if we are going to copy something huge, we can turn this on, and after copying finishes the system will shut down (unless there will be error encountered, or something strange happens)
    • Wait ... [ms] befor shutdown - specifies amount of time for showing shutdown window with cancel possibility
    • Type of shutdown - specifies, if system should be shutdown normally or by force
    • Autosave every ... [ms] - to be able to resume copying after ie. system restert, data describing what has been copied should be written to disk. This option specify interval at which it is done.
    • Application's priority class - specifies the Copy Handler application priority class - use it with caution, because with high priorities the program can cause system to respond very slowly and with the idle - copying data can be very slow.
    • Folder for temporary data - folder for temporary data (look above)
    • Folder with plugins - specifies folder containing plugins for this program (currently unused)
    • Directory with help files - a path to a folder that contains the help files for this program
    • Language - specify language for the program and the shell extension DLL
    • Directory with language files - specifies the path to a directory where the language files are located
  • Status window - options for the status window
    • Refresh status every ... [ms] - interval that specify how often data will be refreshed in the status window
    • Show details in status window - specify, if the right side of status window should be visible (containing details)
    • Automatically remove finished tasks - if copying finishes, some temporary files remain in memory and on disk, thanks to which you can see how many time copying occupied, what was the average transfer, or you have ie. the possibility to restart the task. If we enable this option, then the temporary files will be almost immediately deleted.
  • Miniview - options for mini status window
    • Show file names - specifies if in the miniview file names of files actually copied should appear or only the progress bars.
    • Show single tasks - specifies if the miniview should display all tasks or only one, common progress.
    • Refresh status every ... [ms] - how often miniview should be refreshed
    • Show at program startup - if miniview should be shown at program startup
    • Hide when empty - when no tasks are processed it causes miniview to hide (if later same task will beegin processing - miniview will be automatically shown)
    • Use smooth progress bars - allows user to choose between two styles of progress bars inside miniview: boxed and smooth
  • Choose folder dialog - options associated with folder choosing dialog
    • Show extended view - specifies if shortcuts' list should be visible when showing folder dialog.
    • Dialog width [pixels] - dialog box width in pixels.
    • Dialog height [pixels] - dialog box height in pixels.
    • Shortcuts' list style - specifies the style of the shortcuts' list.
    • Ignore additional shell dialogs - specifies if folder dialog should ignore additional system dialogs (ie. Insert disk, Disk ... not available, ...).
  • Shell - options associated with explorer and shell
    • Show 'Copy' command in drag&drop menu - enables Copy command in drag&drop menu.
    • Show 'Move' command in drag&drop menu - enables Move command in drag&drop menu.
    • Show 'Copy/move special' command in drag&drop menu - enables Copy/move special in drag&drop menu.
    • Show 'Paste' command in context menu - enables Paste command in explorer's context menu.
    • Show 'Paste special' command in context menu - enables Paste special command in explorer's context menu.
    • Show 'Copy to' command in context menu - enables Copy to command in explorer's context menu.
    • Show 'Move to' command in context menu - enables Move to command in explorer's context menu.
    • Show 'Copy/move special to' command in context menu - enables Copy/move special to command in explorer's context menu.
    • Show free space with shortcuts' names - specifies if in the submenus associated with Copy to command (and similar) there should be displayed available free space.
    • Show icons with shortcuts (experimental) - specifies, if in the submenus associated with Copy to command (and similar) there should be displayed shell icons for shortcuts. Experimental option - drawing doesn't work properly on some older systems. If you see some strange submenu (when you select Copy to command or similar one) you should disable this option.
    • Intercept drag&drop operation by left mouse button (experimental) - specifies, if drag&drop operations in explorer (by left mouse button) should be intercepted by this program. Experimental option - first - it doesn't work on some systems (especially the older ones). Second - it causes commands 'Paste' and 'Paste shortcut' (and what goes with it - also Ctrl+V key combination) from explorer's context menu to be intercepted too (program treats the second one just as the first one).
    • Default action for dragging by left mouse button - specifies action that will be performed when dragging files/folders in explorers' windows (if none of the modifying keys (Ctrl, Shift, Alt) will be pressed). Autodetection is now in experimental phase - it "predicts" what is the indicator at mouse cursor - not necessarily correctly.
  • Copying/moving thread - options for copying/moving
    • Auto "copy-rest" of files - specify, if the larger source file should overwrite the smaller destination, or if the destination files should be filled up by the source file.
    • Set attributes of destination files - should attributes for destination files be set ?
    • Set date/time of destionation files - like above, but date/time
    • Protect read-only files - when moving data (at the last phase - deleting files) it specify, if read-only files should be deleted (if not - we got error). It also tells if the destination read-only files should be overwritten.
    • Limit maximum operations running simultaneously to ... - it allows to limit maximum count of operations pending at once. When we specify 0 - we remove limitation.
    • Read tasks size before blocking - if we enable above option, then this option specify if searching for files (and counting its size) should be done before (Yes) or after (No) blocking progress of task
    • Show visual confirmation dialogs - specify if when copying ie. not completely copied file there should be displayed a window with question of overwriting, copying rest, ... .Three grades specify: disabled - the windows are not shown, Normal - windows are shown only in indispensable cases, and Heavy (I haven't found better name :) ) causes asking about everything (almost).
    • Use timed confirmation dialogs - if above dialogs should auto-confirm default option after some time.
    • Time of showing confirmation dialogs - specify time for above window.
    • Auto resume on error - if there was an error encountered - this option specify if the task should be resumed after some time.
    • Auto resume every ... [ms] - specify interval for above option.
    • Default thread priority - specify default priority for copying thread. This value will be assigned to every new task.
    • Disable priority boosting - specifies, if system should boost thread priority if application works in foreground
    • Don't delete files before copying finishes (moving) - it allows to choose how files are moved - either they are deleted (all) after copying all, or one by one (after copying every single file).
    • Create .log files - if program should create log files for every task performed(thanks to it you could report some errors), or look how the copying was performed, or if there was errors, what errors, ...
  • Buffer - options connected with buffers
    • Use only default buffer - if we enable this option - program will use only the default buffer size. In other case program will try to find the proper buffer size by checking the storage medias on which the source and destination files are stored.
    • Default buffer size - specifies the default buffer size. If 'Use only default buffer' option is turned on - this buffer size will be used for all copyings, if it's turned on - this buffer serves for copying files, which are not contained in one of below categories
    • Buffer size for copying inside one physical disk boundary - specifies buffer size for copying data inside one physical disk boundary (when the source files and the destination folder lies on the same physical hard disk).
    • Buffer size for copying between two different disks - specifies buffer size for copying data between two different physical hard disks.
    • Buffer size for copying from CD-ROM - buffer size for copying data from CD-ROM to any other place
    • Buffer size for copying over a network - buffer size used, when copying data from or to a local network
    • Disable buffering for large files - allows to turn off buffering for files with specified size(below) and greater (copying large files without buffering in many cases is faster than copying with buffering).
    • Minimum file size for which buffering should be disabled - specifies minimum file size for which buffering should be disabled (according to my experiments this value on my computer should be about 2MB, but on another systems it may be other).
  • Sounds - specify sound options for program
    • Playing sounds - should program play sounds for some events ?
    • Sound on error - path to .wav file (with sound), which should be played, when error occurs.
    • Sound on copying finished - path to .wav file (with sound), which should be played, after task finishes.
  • Shortcuts - specifies options associated with shortcuts used in explorer's context menus and in folder choosing dialog
    • Defined shortcuts' count - specifies count of currently defined shortcuts. To edit - double click or press the button on the right.
  • Recently used paths - specifies options associated with paths chosed recently as a destination for copy/move operations
    • Count of recent paths - specifies count of paths that are currently remembered. To edit - double click or press the button on the right.
See also: Program's main menu, Folder dialog, Shutdown dialog, Status dialog, Mini status dialog, Explorer's context menus, Feedback dialog - cannot open destination file for writing, Feedback dialog - cannot open source file, Feedback dialog - not enough free space, Feedback dialog - smaller destination file found, Feedback dialog - destination file found, Buffer size dialog, Shortcuts editing dialog, Recent paths editing dialog


Custom copy dialog

  • Source files/folders - contains list of files and folders that are to be copied. You can manage these items by the buttons on the right.
  • Add file(s)... button - allows user to add one or more files to the source list
  • Add folder - allows user to add a folder to a source list
  • Delete - deletes selected items from source list.
  • Import... - allows user to import source files and folders from the file. Each line of the file should contain one full file or folder path.
  • Destination folder - allows user to enter destination path into which the source files will be copied or moved. You can change it manually be entering path from keyboard or by clicking the '...' button on the right.
  • Operation type - specifies operation that will be performed on source files
  • Priority - specifies thread priority at which the working thread will work.
  • Count of copies - specifies count of copies of the source files that should be performed. Possible values are from range 0..~240. This is useful when copying something small to the failure-prone storage medium (ie. floppy disk).
  • Buffer sizes - specifies sizes of the buffer that will be used to copy or move the source data into destination location
  • Filtering - when checked - allows user to specify filters to be used when copying. Buttons at right side allow user to add or remove a filter. Add button opens the filter dialog.
  • Advanced options
    • Do not create destination directories - copy files loosely to destination folder - when selected it causes task not to create destination directories and to copy all found files in every searched folder to the destination folder, but without creating the folders that are usually created.
    • Create directory structure in the destination folder (relatively to root directory) - when copying files program will create the whole path found on source media in the destination directory.
    • Do not copy/move the contents of files - only create it (empty) - acts as a normal copyin/moving, but does not copy the contents of files. The destination files will be empty. Be careful when moving data that way.
See also: Explorer's context menus, Program's main menu, Filter dialog


Explorer's context menus

When using shell integration some items (commands) are added to explorer context menus. There are two types of explorer menus which are modified by the Copy Handler:
  • Drag&drop context menu - displayed when you drag some files and/or folders from one place to another by right mouse button.
    • (CH) Copy here - copies the dragged files to the place where the files were dropped
    • (CH) Move here - moves the dragged files to the place where the files were dropped
    • (CH) Copy/move special... - opens the custom copy dialog where you can adjust some settings regarding the drag&drop operation.
  • Standard context menu - Displayed when you click on any file or folder (or folder background).
    • (CH) Paste - enabled only when menu was opened by r-clicking on the folder or folder's background and when in clipboard there are some files or folders. Works the same way the normal Windows paste command, but the operation is processed by Copy Handler instead of Windows.
    • (CH) Paste special... - enabled only when menu was opened by r-clicking on the folder or folder's background and when in clipboard there are some files or folders. Works a bit similar to the previous option, but displays custom copy dialog where user can adjust some settings before operation begins.
    • (CH) Copy to - expandable menu. Enabled only when menu was opened by r-clicking on file or folder (not folder background) and when there is at least one shortcut defined in configuration section 'Shortcuts'. Copies the selected files to the location where the selected shortcut points.
    • (CH) Move to - command almost identical to the above one, but instead of copying it moves files and foldeers.
    • (CH) Copy/move special to... - works similarly to the 'copy to' command, but displays the custom copy dialog where user can adjust some settings before operation starts.
Each command in explorer's context menus may be enabled or disabled in configuration dialog in section 'Shell'.
See also: Configuration dialog, Custom copy dialog


Feedback dialog - cannot open destination file for writing

This dialog is being shown by a task, when the processing thread cannot open the destination file for writing. The dialog displays which file couldn't be open and the error code.
  • Retry - tries again to open the file for writing.
  • Ignore - ignores this error and skips the file.
  • Ignore all - like the above button, but also ignores the next errors of this type.
  • Wait - changes state of the task to error. If the configuration option 'Auto resume on error' is set - the task will be resumed in a configured time.
  • Cancel - cancels the task.
See also: Feedback dialog - cannot open source file, Feedback dialog - not enough free space, Feedback dialog - smaller destination file found, Feedback dialog - destination file found


Feedback dialog - cannot open source file

This dialog is displayed by the task when the working thread cannot open the source file to be copied. Dialog displays info about expected file and the found one. Also shows the encountered error.
  • Retry - tries again to open the source file.
  • Ignore - ignores this error and skips the file.
  • Ignore all - like the above button, but also ignores the next errors of this type.
  • Wait - changes state of the task to error. If the configuration option 'Auto resume on error' is set - the task will be resumed in a configured time.
  • Cancel - cancels the task.
See also: Feedback dialog - cannot open destination file for writing, Feedback dialog - not enough free space, Feedback dialog - smaller destination file found, Feedback dialog - destination file found


Feedback dialog - destination file found

This dialog is displayed when the working thread finds that there is a file in the destination location that is greater or equal in size to file being copied. If the files are identical - you should ignore. But if they differs you should recopy.
  • Recopy - recopies the whole file from the beginning
  • Recopy all - like the above, but does the 'Recopy' for all subsequent situations, where the destination file is greater or equal in size to source one.
  • Ignore - ignores this info, and skips the file.
  • Ignore all - like the above button, but also ignores the next infos of this type.
  • Cancel - cancels the task.
See also: Feedback dialog - cannot open destination file for writing, Feedback dialog - cannot open source file, Feedback dialog - not enough free space, Feedback dialog - smaller destination file found


Feedback dialog - not enough free space

This dialog is displayed when there is not enough free space in the destination location to copy or move the source files. Dialog automatically refreshes the count of free space on drive.
  • Retry - tries again to copy the files.
  • Continue - ignores missing free space and continues copying.
  • Cancel - cancels the task.
See also: Feedback dialog - cannot open destination file for writing, Feedback dialog - cannot open source file, Feedback dialog - smaller destination file found, Feedback dialog - destination file found


Feedback dialog - smaller destination file found

This dialog is displayed when the working thread finds that there is a file in the destination location that is smaller than the file being copied. The possible reasons are:
  • there is an older version of the file in the destination location; in that case you should recopy the file
  • there is a part of the file being copied in the destination location; the file were not copied to the end; you should copy rest the file

Possible operations:
  • Copy rest - copies the rest of a file.
  • Copy rest all - as above, but does the 'Copy rest' for all subsequent situations, where the destination file is smaller than the source one.
  • Recopy - recopies the whole file from the beginning
  • Recopy all - like the above, but does the 'Recopy' for all subsequent situations, where the destination file is smaller than the source one.
  • Ignore - ignores this info, and skips the file.
  • Ignore all - like the above button, but also ignores the next infos of this type.
  • Cancel - cancels the task.
See also: Feedback dialog - cannot open destination file for writing, Feedback dialog - cannot open source file, Feedback dialog - not enough free space, Feedback dialog - destination file found


Filter dialog

This dialog could be displayed only from the custom copy dialog for adding/changing the filtering options for the task.
  • Include mask - you may enter the mask of files that will be copied (ie. *.jpg - copies only the jpg files). If you want to specify more than one mask - separate it by '|' sign - ie. *.jpg|*.gif|*.bmp.
  • Exclude mask - specifies mask of the files that will not be copied. Mask is enteres in a way described in Include mask
  • Filtering by size - allows to specify up to two size conditions from the components that lies below. Only files that matches all the conditions are copied
  • Filtering by date - allows user to specify max. two conditions regarding date and time of the file. Yo may select one of three date types (last access time, last write time and creation time).
  • By attributes - copies only files which matches the specified attibutes. Grayed check boxes means that this attribute doesn't matter.
All the filter settings must match to the file attributes in order to copy the file.
See also: Custom copy dialog


Folder dialog

This is the dialog displayed when the configuration option 'Monitoring clipboard' is enabled and some filenames are in the clipboard.

The left part of the dialog contains list of shortcuts. It could be used to select path faster. The four buttons are used for changing view of the shortcut list. The two buttons below allows adding and deleting shortcuts.
The right part of the dialog contains the tree view with folder's structure. You can select a path from it or enter the whole path manually in the combo box below. The button above creates a new folder in a currently selected folder.

See also: Configuration dialog, Program's main menu


Main menu description

Show status... | Shows status window which displays detailed info about tasks (in progress, finished, cancelled, ...).
Show mini-status... | Shows mini-status window that shows simplified view of a tasks in progress.
Enter copy parameters... | Shows custom copy parameters dialog that allows user to enter a source files and folders to be copied, destination folder and to specify needed additional options.
Register shell extension dll | If you have installed shell extension dll (when it is in a folder from which you have run the program) it allows to register it in system registry (this allows using additional commands in explorer context menus).
Unregister shell extension dll | Command allows to unregister shell extension dll (it will remove all commands in explorer context menus).
Monitor clipboard | This command is closely related to 'Clipboard monitoring' option ('program' section) in configuration. When you choose this command it is like you are changing the configuration option.
Shutdown after finished | Command closely related to the 'Shutdown system after copying finishes' option ('program' section) in configuration. When you choose this command it is like you were changing the appropriate configuration option.
Options... | Shows configuration dialog where you can fully configure and adjust program to your needs.
Help... | Shows the help file.
About... | Shows dialog with the info about this program.
Exit | Ends working of this program.
See also: Status dialog, Mini status dialog, Custom copy dialog, Explorer's context menus, Configuration dialog


Mini-status window

This dialog shows short info about currently pending tasks. It could be configured in configuration dialog in section 'Miniview'.
See also: Status dialog, Configuration dialog


Recent paths edit dialog

This dialog is displayed by the configuration dialog to edit the recently used paths.
  • Recently used paths - list of recently used paths that you may modify.
  • Path - using the 3 buttons (Add, Update and Delete) you can may operate on the displayed paths to make it more appropriate.
See also: Configuration dialog, Shortcuts editing dialog


Replace paths dialog

This dialog allows user to change the source path of a selected task in the status window to a new value.
  • Source paths - specifies the source paths that at the beginning were added to this task. You can select one of them or you may enter path manually into the edit box below.
  • Change to - here you can enter the new path. You may do it manually by entering text from the keyboard or by clicking the '...' button and selecting folder from the window that opens.
See also: Advanced context menu, Status dialog


Shortcuts edit dialog

This dialog could be displayed by the configuration dialog to edit the shortcuts that are used in explorer context menus and in the folder dialog.
  • Shortcuts - list of the currently defined shortcuts.
  • Move up/Move down - these two buttons allow to change the order of the items in the list.
  • Shortcut's properties - this set of items allow user to manage the shortcuts in the list. Each shortcut has the name that is displayed and an associated path.
See also: Recent paths editing dialog, Configuration dialog


Shutdown dialog

This dialog is displayed when the configuration option 'Shutdown system after copying finishes' (in the 'Program section') is set and all the tasks are finished.
See also: Configuration dialog


Status dialog

  • Left side of of the window
    • Operations list window - displays list of tasks with different status (finished, cancelled, ...). For each task there is given status of it, current filename being processed, destination folder to which files are stored and percentage progress of a task.
    • Pause button - pauses selected task. If another task is waiting for this one to be finished it now starts.
    • Resume button - resumes work of the selected, paused task. Also if task is in wait state (waiting for another one to finish) this button causes it to start. When used on 'wait state' task it ignores configuration option 'Limit maximum operations running simultaneously' ('Copying/moving thread' section).
    • Restart button - causes selected task to restart. Causes task to run from the beginning (with searching for files).
    • Cancel button - cancels the currently selected task.
    • Remove button - when the task is finished or cancelled this command removes task from the list. If task is running program asks if user want to cancel current task.
    • Pause/all button - work like Pause button, but for all of the tasks.
    • Resume/all button - work like Resume button, but does not ignore the configuration option 'Limit maximum operations running simultaneously' ('Copying/moving thread' section).
    • Cancel/all button - cancels all the tasks.
    • Remove/all button - removes all the cancelled and finished tasks from the list.
    • Restart/all button - restarts all the tasks from the list.
    • Stick button - causes the status dialog to be positioned in right-bottom corner of the screen.
    • '<<' '>>' button - changes the dialog view to simple/advanced.
    • Advanced button - Shows menu with advanced options regarding one or more tasks from the list.
  • Current selection statistics - statistics for the task selected in Operations list window.
    • Associated file - filename that contains info about current task. When you restart the system, Copy Handler loads task info from this file. Files are placed in a location specified by configuration option 'Folder for temporary data' (in 'Program' section).
    • Operation - specifies type and status of the selected task.
    • Source object - current filename that is being processed (copied or moved into destination location).
    • Destination object - destination folder into which the selected task copies the files and folders.
    • Buffer size - specifies the buffer size which is currently being used for the copying. You may change the size of the buffers by clicking on '...' button on the right. It will bring up the buffer size dialog.
    • Thread priority - task priority at which the thread is running. You can change it by clicking the '>' button on the right and choosing from the menu needed priority.
    • Comments - displays error descriptions if any occurred.
    • View log button - shows log file contents associated with the current task.
    • Processed - gives info on how many files and folders has been processed/count of all files and folders, size of data that has been processed/count of all data and passes that has been made/count of all passes. There are more than 1 pass when you specify more than one copy to make.
    • Time - displays elapsed time (of this tasks' working), the total estimated time that the operation would take, and the estimated time left.
    • Transfer - shows current transfer rate for this task (current and average). The current speed of copying is measured by dividing the size of data that has been copied in the last interval of time (it is about value specified in configuration option 'Refresh status every ... [ms]' in 'Status dialog' section) by the real, precise time that passed when copying the data. The data may be a bit inaccurate when using large buffers. Program reads one buffer at a time, so it may happen that when using large buffers or a small refresh intervals the transfer will drastically change from 0 B/s to i.e. 24MB/s (for 24MB buffer). Average speed is measured by dividing size of all the copied data by the overall time.
    • Progress - file-size based progress bar.
  • Global statistics
    • Processed - very similar to 'Processed' from above, but it displays info about all the tasks in a list (it doesn't matter if it's finished, cancelled, or running).
    • Transfer - displays current transfer for all running tasks in a list
    • Progress - size-based progress bar for all the tasks in a list (ignores state of a task. Counts all of them).
See also: Configuration dialog, Advanced context menu, Replace paths dialog, Buffer size dialog


Contact/support

If have any suggestions, like/do not like something regarding this program - let me know:

support@copyhandler.com

copyhandler@o2.pl

If you have found a bug in the program - read how to report it.

If you like this program and would like to support it's future development - you may donate something to my bank account:
BRE SA-WBE/Lodz (Poland)
78 1140 2004 0000 3102 3116 3975

Discussion forums:

General discussion forum - you can send there some questions, bugs reports and other...but not the spam.
Page [http://groups.yahoo.com/group/copyhandler]
Subscribe [copyhandler-subscribe@yahoogroups.com]
Unsubscribe [copyhandler-unsubscribe@yahoogroups.com]
Post message [copyhandler@yahoogroups.com]

Developer's discussion forum for Copy Handler - for comments regarding Copy Handler's code, connected with programming CH and other...
Page [http://groups.yahoo.com/group/chdev]
Post message [chdev@yahoogroups.com]
Subscribe [chdev-subscribe@yahoogroups.com]
Unsubscribe [chdev-unsubscribe@yahoogroups.com]

Also if you're looking for the newest version - take a look at:
http://www.copyhandler.com
http://www.copyhandler.prv.pl
See also: Bugs reporting, License, Thanks


Bug reports

If you encounter a problem with the program that may be a result of a programming error you may write to support@copyhandler.com or copyhandler@o2.pl.

All of the bug reports are welcome, but before you write:
  • make sure you have the latest version of the program. You can download it from the web page.
  • [concerning only the zip version] make sure you have properly replaced the shell extension dll. Most of the errors comes from using old dll with a new program. If you have used the previous version of program - unregister shell extension dll, restart the computer, delete the old shell extension dll, copy the new one into that place and register the extension in the program's menu. See also the installation/deinstallation procedure.
What the mail should contain (not all is required, but everything may be helpful) ?
  • The detailed bug description (what happened, how can I reproduce the error). This is required; if I do not know how to reproduce the error how can I fix it ?
  • The configuration file of the Copy Handler (copy handler.ini) if the error could be related to the options set. If you are not sure - include compressed (zip or rar archives preferred) configuration file in the mail. Not required, but in some cases may be helpful.
  • The system configuration (version of a Windows system, version of the Internet explorer installed in system, version of Copy Handler that you have used). Not required, but helpful - some problems appears only in specific systems.
  • The speed of the processor and count of RAM. Not required, but in some cases helpful.
  • Any other info (perhaps a screen shot) that may be helpful.
If you want to include any attachment with the mail - make sure it's in the small format (ie. for screenshots and images make sure they are in .jpg or .gif format. Absolutely do not send images in .bmp format). Any other attachment should be compressed by ZIP or RAR compressor.
See also: Contact/support, Known bugs/issues, Program's history, Installation


            GNU GENERAL PUBLIC LICENSE
               Version 2, June 1991

 Copyright (C) 1989, 1991 Free Software Foundation, Inc.
                          675 Mass Ave, Cambridge, MA 02139, USA
 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.

                Preamble

  The licenses for most software are designed to take away your
freedom to share and change it.  By contrast, the GNU General Public
License is intended to guarantee your freedom to share and change free
software--to make sure the software is free for all its users.  This
General Public License applies to most of the Free Software
Foundation's software and to any other program whose authors commit to
using it.  (Some other Free Software Foundation software is covered by
the GNU Library General Public License instead.)  You can apply it to
your programs, too.

  When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it
in new free programs; and that you know you can do these things.

  To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

  For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

  We protect your rights with two steps: (1) copyright the software, and
(2) offer you this license which gives you legal permission to copy,
distribute and/or modify the software.

  Also, for each author's protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software.  If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors' reputations.

  Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary.  To prevent this, we have made it clear that any
patent must be licensed for everyone's free use or not licensed at all.

  The precise terms and conditions for copying, distribution and
modification follow.

            GNU GENERAL PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. This License applies to any program or other work which contains
a notice placed by the copyright holder saying it may be distributed
under the terms of this General Public License.  The "Program", below,
refers to any such program or work, and a "work based on the Program"
means either the Program or any derivative work under copyright law:
that is to say, a work containing the Program or a portion of it,
either verbatim or with modifications and/or translated into another
language.  (Hereinafter, translation is included without limitation in
the term "modification".)  Each licensee is addressed as "you".

Activities other than copying, distribution and modification are not
covered by this License; they are outside its scope.  The act of
running the Program is not restricted, and the output from the Program
is covered only if its contents constitute a work based on the
Program (independent of having been made by running the Program).
Whether that is true depends on what the Program does.

  1. You may copy and distribute verbatim copies of the Program's
source code as you receive it, in any medium, provided that you
conspicuously and appropriately publish on each copy an appropriate
copyright notice and disclaimer of warranty; keep intact all the
notices that refer to this License and to the absence of any warranty;
and give any other recipients of the Program a copy of this License
along with the Program.

You may charge a fee for the physical act of transferring a copy, and
you may at your option offer warranty protection in exchange for a fee.

  2. You may modify your copy or copies of the Program or any portion
of it, thus forming a work based on the Program, and copy and
distribute such modifications or work under the terms of Section 1
above, provided that you also meet all of these conditions:

    a) You must cause the modified files to carry prominent notices
    stating that you changed the files and the date of any change.

    b) You must cause any work that you distribute or publish, that in
    whole or in part contains or is derived from the Program or any
    part thereof, to be licensed as a whole at no charge to all third
    parties under the terms of this License.

    c) If the modified program normally reads commands interactively
    when run, you must cause it, when started running for such
    interactive use in the most ordinary way, to print or display an
    announcement including an appropriate copyright notice and a
    notice that there is no warranty (or else, saying that you provide
    a warranty) and that users may redistribute the program under
    these conditions, and telling the user how to view a copy of this
    License.  (Exception: if the Program itself is interactive but
    does not normally print such an announcement, your work based on
    the Program is not required to print an announcement.)

These requirements apply to the modified work as a whole.  If
identifiable sections of that work are not derived from the Program,
and can be reasonably considered independent and separate works in
themselves, then this License, and its terms, do not apply to those
sections when you distribute them as separate works.  But when you
distribute the same sections as part of a whole which is a work based
on the Program, the distribution of the whole must be on the terms of
this License, whose permissions for other licensees extend to the
entire whole, and thus to each and every part regardless of who wrote it.

Thus, it is not the intent of this section to claim rights or contest
your rights to work written entirely by you; rather, the intent is to
exercise the right to control the distribution of derivative or
collective works based on the Program.

In addition, mere aggregation of another work not based on the Program
with the Program (or with a work based on the Program) on a volume of
a storage or distribution medium does not bring the other work under
the scope of this License.

  3. You may copy and distribute the Program (or a work based on it,
under Section 2) in object code or executable form under the terms of
Sections 1 and 2 above provided that you also do one of the following:

    a) Accompany it with the complete corresponding machine-readable
    source code, which must be distributed under the terms of Sections
    1 and 2 above on a medium customarily used for software interchange; or,

    b) Accompany it with a written offer, valid for at least three
    years, to give any third party, for a charge no more than your
    cost of physically performing source distribution, a complete
    machine-readable copy of the corresponding source code, to be
    distributed under the terms of Sections 1 and 2 above on a medium
    customarily used for software interchange; or,

    c) Accompany it with the information you received as to the offer
    to distribute corresponding source code.  (This alternative is
    allowed only for noncommercial distribution and only if you
    received the program in object code or executable form with such
    an offer, in accord with Subsection b above.)

The source code for a work means the preferred form of the work for
making modifications to it.  For an executable work, complete source
code means all the source code for all modules it contains, plus any
associated interface definition files, plus the scripts used to
control compilation and installation of the executable.  However, as a
special exception, the source code distributed need not include
anything that is normally distributed (in either source or binary
form) with the major components (compiler, kernel, and so on) of the
operating system on which the executable runs, unless that component
itself accompanies the executable.

If distribution of executable or object code is made by offering
access to copy from a designated place, then offering equivalent
access to copy the source code from the same place counts as
distribution of the source code, even though third parties are not
compelled to copy the source along with the object code.

  4. You may not copy, modify, sublicense, or distribute the Program
except as expressly provided under this License.  Any attempt
otherwise to copy, modify, sublicense or distribute the Program is
void, and will automatically terminate your rights under this License.
However, parties who have received copies, or rights, from you under
this License will not have their licenses terminated so long as such
parties remain in full compliance.

  5. You are not required to accept this License, since you have not
signed it.  However, nothing else grants you permission to modify or
distribute the Program or its derivative works.  These actions are
prohibited by law if you do not accept this License.  Therefore, by
modifying or distributing the Program (or any work based on the
Program), you indicate your acceptance of this License to do so, and
all its terms and conditions for copying, distributing or modifying
the Program or works based on it.

  6. Each time you redistribute the Program (or any work based on the
Program), the recipient automatically receives a license from the
original licensor to copy, distribute or modify the Program subject to
these terms and conditions.  You may not impose any further
restrictions on the recipients' exercise of the rights granted herein.
You are not responsible for enforcing compliance by third parties to
this License.

  7. If, as a consequence of a court judgment or allegation of patent
infringement or for any other reason (not limited to patent issues),
conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License.  If you cannot
distribute so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you
may not distribute the Program at all.  For example, if a patent
license would not permit royalty-free redistribution of the Program by
all those who receive copies directly or indirectly through you, then
the only way you could satisfy both it and this License would be to
refrain entirely from distribution of the Program.

If any portion of this section is held invalid or unenforceable under
any particular circumstance, the balance of the section is intended to
apply and the section as a whole is intended to apply in other
circumstances.

It is not the purpose of this section to induce you to infringe any
patents or other property right claims or to contest validity of any
such claims; this section has the sole purpose of protecting the
integrity of the free software distribution system, which is
implemented by public license practices.  Many people have made
generous contributions to the wide range of software distributed
through that system in reliance on consistent application of that
system; it is up to the author/donor to decide if he or she is willing
to distribute software through any other system and a licensee cannot
impose that choice.

This section is intended to make thoroughly clear what is believed to
be a consequence of the rest of this License.

  8. If the distribution and/or use of the Program is restricted in
certain countries either by patents or by copyrighted interfaces, the
original copyright holder who places the Program under this License
may add an explicit geographical distribution limitation excluding
those countries, so that distribution is permitted only in or among
countries not thus excluded.  In such case, this License incorporates
the limitation as if written in the body of this License.

  9. The Free Software Foundation may publish revised and/or new versions
of the General Public License from time to time.  Such new versions will
be similar in spirit to the present version, but may differ in detail to
address new problems or concerns.

Each version is given a distinguishing version number.  If the Program
specifies a version number of this License which applies to it and "any
later version", you have the option of following the terms and conditions
either of that version or of any later version published by the Free
Software Foundation.  If the Program does not specify a version number of
this License, you may choose any version ever published by the Free Software
Foundation.

  10. If you wish to incorporate parts of the Program into other free
programs whose distribution conditions are different, write to the author
to ask for permission.  For software which is copyrighted by the Free
Software Foundation, write to the Free Software Foundation; we sometimes
make exceptions for this.  Our decision will be guided by the two goals
of preserving the free status of all derivatives of our free software and
of promoting the sharing and reuse of software generally.

                NO WARRANTY

  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
REPAIR OR CORRECTION.

  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.

             END OF TERMS AND CONDITIONS

    Appendix: How to Apply These Terms to Your New Programs

  If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these terms.

  To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.

    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) 19yy  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Also add information on how to contact you by electronic and paper mail.

If the program is interactive, make it output a short notice like this
when it starts in an interactive mode:

    Gnomovision version 69, Copyright (C) 19yy name of author
    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
    This is free software, and you are welcome to redistribute it
    under certain conditions; type `show c' for details.

The hypothetical commands `show w' and `show c' should show the appropriate
parts of the General Public License.  Of course, the commands you use may
be called something other than `show w' and `show c'; they could even be
mouse-clicks or menu items--whatever suits your program.

You should also get your employer (if you work as a programmer) or your
school, if any, to sign a "copyright disclaimer" for the program, if
necessary.  Here is a sample; alter the names:

  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
  `Gnomovision' (which makes passes at compilers) written by James Hacker.

  <signature of Ty Coon>, 1 April 1989
  Ty Coon, President of Vice

This General Public License does not permit incorporating your program into
proprietary programs.  If your program is a subroutine library, you may
consider it more useful to permit linking proprietary applications with the
library.  If this is what you want to do, use the GNU Library General
Public License instead of this License.
See also: Contact/support


Program history/what's new

  • 1.28
    • Fixed bug where files which name starts with a dot were not copied.
    • Added some new translations
    • Many internal changes in the code (changed stl support to the stlPort from http://www.stlport.com)
  • 1.26
    • corrected a displaying of the paths in the status dialog box
    • corrected on-the-fly language change in the task list in the status dialog box
    • corrected handling of the directory paths in configuration
    • when a "not enough free space" dialog appears it automatically disappears (now) as soon as there is enough space to perform the operation
    • change in program's file names
    • changed the handling of the languages; now they are based on text files instead of dll's
    • corrected shell extension bug (problems with the CTRL key and detecting the operation)
  • 1.25
    • added help files to the program instead of readme files
    • corrected bug when the newly created shortcuts (in folder choosing dialog) were not being saved
    • some small optimizations and corrections
  • 1.20
    • this program has changed licensing to GNU General Public License (what means, that the full source code is available at http://www.copyhandler.prv.pl)
    • added language plugin support
    • changed installer to NSIS
    • optimized tray restart detection
    • modified about dialog
    • now all strings are being read from resource tables
    • modified handling of configuration - it supports now applying, and changing language on the fly
    • when registering or unregistering shell extension dll from program's menu fails - it displays error code
    • added section 'Log file' which is currently unused
    • now pasting by CH doesn't clear the clipboard
    • some small optimizations
  • 1.13i
    • Corrected error connected with detecting partitions (the same disk or not the same) on newer computers or with much of hardware inside
    • Changed some texts - ie. in English there is One disk instead of OD
    • Corrected detection of floppy drive/path to floppy in choosing destination folder dialog
    • Modified some dialogs to be displayed on taskbar (ie. status window)
    • Corrected bug connected with manually entering a path in some windows - previously the count of chars depended on size of the window
    • Added french language to a program (thanx to Julien (Vk))
    • Now the executable and dll are really packed with UPX, not like in 1.13g version ;)
  • 1.13g
    • corrected error connected with 'Copy to' explorer menu item (and similar ones) (in previous version it doesn't do anything)
    • added two new options connected with priority manipulation - application priority and disabling thread priority boosting
    • corrected error connected with counting free space on disk (if size of free space on disk was equal to size of resources being copied program displayed window with info about missing disk free space)
    • corrected error connected with files' copying which dates were from outside the range of 1970...2038 year (program crashed)
    • added capability of changing the shortcuts' order
    • program and dll were compressed by UPX Software
  • 1.13e
    • corrected some errors in program's text - ie. missing 'special' word in context menu (in english language version)
    • corrected a little work of experimental option 'Dragging by left mouse button'
    • added function for importing file paths to copy from text file
    • added function for forcing of create full source paths in destination folder
    • the taskbar icon will automatically reappear when explorer restarts
    • additional configuration option - choosing of default action for dragging files with left mouse button (if option 'Intercept ...' is enabled)
  • 1.13
    • Corrected error - commands in explorer's 'File' menu were displayed many times - the more times 'File' menu was opened the more commands appeared
    • Corrected annoying behaviour - saving state of finished/paused/cancelled tasks were done unnecessarily (ie. when using disk defragmenters operation was interrupted each time the program was saving temporary data) - now when going to one of those states the temporary data is stored only once.
  • 1.12 Final
    • Little changes in polish version of program - to "more polish"
    • Changed standard path for temporary files to system TEMP folder
    • Corrected error connected with changing buffer sizes in status dialog
    • Removed unused file Quick access data.ini - contents were moved into file copy handler.ini
    • Corrected some stuff connected with incompatibilities within Windows systems - now program should properly work on Windows 95/98/Me/NT4/2000/XP
    • Changed a little (actually rewritten) dialog for choosing destination folder
    • Changed 'copy/move settings' dialog and expanded filtering capabilities
    • Corrected shell handling - additional commands and two experimental options (works only on some systems)
    • A few other things which aren't important enough to write about...
  • 1.11
    • added new option - chosing progress bar style in mini status (smooth/boxed)
    • corrected starting state of .ini file - ineffective buffer sizes settings
  • 1.10 Final
    • corrected detecting partitions lying on one physical disk
    • added setup program for handling installation
    • added info about new e-mails in about box
    • removed automatic shell extension register at program start - instead setup program will handle this
    • corrected handling of automatic program loading with system
  • 1.10 beta 4
    • corrected error connected with copying data in Windows NT/2000/XP with disabled buffering
    • corrected speed of pausing, resuming, ... of tasks, especially at NT series of Windows (NT/2000/XP)
    • corrected bug connected with setting destination folder for temporary data
    • added autodetection of buffer size and 5 different buffer sizes for 5 different types of copying; changed way to enter buffer sizes, ...
    • corrected strange effects connected with large buffer sizes
    • additional options in program's main menu - registration/unregistration of shell extension DLL
    • showing status window now cause autohide of mini status
    • when entering path to sounds and to temporary folder you can use some shortcuts (these paths doesn't end with \, so you have to add it when modifying path ie. < WINDOWS >\media; paths entered that way has to be enter uppercase - < WINDOWS > instead < windows > or < Windows >; paths entered that way contain no spaces, though it may look differently):
      • < WINDOWS > - windows directory (ie. c:\windows)
      • < TEMP > - directory for temporary data (ie. c:\windows\temp)
      • < SYSTEM > - system directory (ie. c:\windows\system)
      • < APPDATA > - directory for application's data (ie. c:\windows\AppData)
      • < DESKTOP > - directory with files that are places on desktop (ie. c:\windows\desktop)
      • < PERSONAL > - private directory for logged user (ie. c:\my documents)
    • corrected shutdown of program (by the menu option 'exit' and by system shutdown) - now program saves its state before exit; program's shutdown was also speeded up
    • now system shutdown allows cancelling for some time and also works under Windows NT/2000/XP; additionally, when auto system shutdown after finished is enabled and none of tasks isn't currently processed - program will not shut down the system - it'll wait for any task to start; you may also set type of shutdown (force/normal)
    • corrected mini status from the point of view of cooperation with Windows NT/2000/XP - now, you can use buttons placed on caption bar of mini status
    • pressing resume button on waiting task will cause that task to start, even if normally 'limiting operations' do not allow task to start
    • if 'limit maximum operations' option is enabled - the tasks will be started in order they appear on the task list
    • changed a little handling of .log files and errors - now, except of error number there is shown info about error, and a place in program where error occurs
    • in status window added additional info about temporary file associated with given task
    • a little modifications of UI (icons were taken from Windows XP - I hope nobody would be angry), optimalizations, other...
  • 1.03
    • corected many errors connected with displaying text - especially when selecting large fonts in display properties (control panel), or setting some strange color and size scheme
    • changed handling copy without buffering - previously file was copied by multiplies of buffer size. If read data size wasn't the multiply of the buffer size then program stored overfluous info to destination file, and after a moment changed size of the file to a size of source file. Now copying has a two passes - first copies files by the multiplies of buffer size, and the second the rest data (concerns only files copying with no buffering)
    • added new option in program's main menu - shutting down the systemafter finished copying
    • corrected handling of displaying dialog box informing about missing enough free space on disk - now, when copying was interrupted in a half and then resumed - when calculating needed free space there is being taken the copied part into consideration.
    • corrected (a little) visual confirmation dialogs - they're now a little more 'clean', but further they're wretched
    • corrected error - limiting count of simultaneously performed operations in some situations stops working correctly, and requires to restart program.
    • corrected moving data inside one partition boundary - previously moving data this way caused generating an error 'File exists' if there was folder or file with the same name with this being copied
    • corrected incorrectly showed progress in case copying data with disabled buffering (it may caused some other problems of which I haven't known).
    • little corrections to a tab order in many dialogs
  • 1.02
    • replaced BCMenu old version with the new one (user interface change: default item is shown with bold atribute of text)
    • now there isn't showed 0% after finished moving files (not folders) inside one partition boundary.
    • added feature for copying files without buffering (it's usable when copying large files)
      • buffer sizes are rounded up to the nearest multiple of 64kB.
      • if file is being copied without buffering and has size which is not multiple of 4kB then destination file in one moment will have size greater than source file. (Attention: If in this moment copying will be interrupted, then later resumed - program will start copying from beginning, unless option of using visual confirmation dialogs is set to heavy).
      • there are two new options - first allows enabling/disabling of using copy wihout buffering, the secode allows to specify minimal file size, which qualify it to copy without buffering (copying small files without buffering will cause to lower copying speed)
    • corrected handling of configuration (now it shouldn't block other parts of program)
    • corrected tab order in some windows
    • changed arrangement of main menu in program; added new item in this menu - now 'Monitoring clipboard' could be chosen from that menu (not only from Options)
  • 1.01a
    • corrected DLL cooperation with ANSI version of Windows (98/Me)
  • 1.01
    • corrected situation, when missing source file (with visual confirmation dialogs turned on) caused program to do the "forbidden operation".
    • now, the window for custom copy parameters shows the operation type (copy, move)
    • corrected cooperation of program with UNICODE versions of Windows (NT/2000/XP) - now program (really the DLL) should work properly under that systems.
    • if "View log" doesn't show notepad with log file then it shows info with error
    • in choose destination directory window (with enabled clipboard monitoring) appear info on disk's free space
    • if encountered copy error, then automatically retrying will be performed after some time (set in options) counted from that encounter, not like earlier from last retry attempt.
    • if program state, that there is no room for the files (it's checked at the beginning of operation) then it show some info about it.
    • corrected incorrectly showed strings for Explorer context menus.
See also: Known bugs/issues


Known bugs/issues

  • moving data over the network always causes files' contents to be copied, but in some cases it could be done without copying (ie. when browsing local computer through the Network Neighbourhood).
  • intercepting drag&drop operations by program (by left mouse button) doesn't work on older systems (especially Windows 98 and 95).
  • drawing icons in explorer context menus doesn't work on older Windows versions
  • when copying many small files the program is rather slow
See also: Program history, Reporting bugs, Contact/support


Thanks list

I'd like to thank everyone who had helped me in creating this program - in particular:
People that has the "physical" contribution into the project:
  • El Magico - installer script, author of many bug-reports, great ideas...
  • Barnaba - currently handles home page of this program
  • Tomas S. Refsland - server and domain sponsor
  • Kaleb - previous webmaster of a Copy Handler site
  • Marcin Kedzia & DMK Project - the recent sponsor of our web page - http://www.dmkproject.pl
Authors of the language packs shipped with the program:

For the current list of installed language packs look at program's about box.

People who's code I have used in a current version of the program (obtained at http://www.codeguru.com):
  • Antonio Tejada Lacaci - CFileInfoArray (with major modifications)
  • Keith Rule - CMemDC
  • Brett R. Mitchell - CPropertyListCtrl (with some additions)
People/institutions - authors of the programs that has been used to create Copy Handler:
  • Microsoft - author of: Visual Studio 6.0, all the Windows systems and some icons (http://www.microsoft.com)
  • Markus Oberhumer & Laszlo Molnar - UPX Software - executable files compression (http://upx.tsx.org)
Other people (for many things)...:
  • Chis Octavian
  • Peter Bijl
  • Sebastian Schuberth
If you feel you should be listed here, and you are not - please write to me.
See also: Contact/support, License


.topic 0
No topic has been associated with this item.


.topic 0x00
No topic has been associated with this item.

.topic 1
Closes this window.

.topic 0x4B2
Link to this program's home page.

.topic 0x4E7
Link to the web page of our web page sponsor.

.topic 0x4B6
My preferred mail address. Write an e-mail here if you want to report a bug, to let us know your opinion about the program or if you want to ask for something.

.topic 0x4B7
My secondary mail address. Write an e-mail here if you want to report a bug, to let us know your opinion about the program or if you want to ask for something.

.topic 0x4B8
Link to the the page with a discussion forum. If you want to receive the new versions' notifications you should subscribe this forum.

.topic 0x4B9
Link to an e-mail address you should write to subscribe the 'copy handler' discussion list.

.topic 0x4BA
Link to an e-mail address you should write to unsubscribe the 'copy handler' discussion list.

.topic 0x4BB
You should write an e-mail to this address if you want all subscribed users to receive the mail.

.topic 0x4BC
Link to the the page with a discussion forum for Copy Handler's developers. You should subscribe this discussion forum if you are writing a plugin for Copy Handler (ie. language translation). When some strings would be added (or changed) to the program I would post the mail to this forum with the change log. Also if you have any comments about the Copy Handler's source code you may write here.

.topic 0x4BD
Link to an e-mail address you should write to subscribe the 'chdev' discussion forum.

.topic 0x4BE
Link to an e-mail address you should write to unsubscribe the 'chdev' discussion forum.

.topic 0x4BF
You should write an e-mail to this address if you want all subscribed users of chdev discussion list to receive the mail.

.topic 0x4AE
The list of people I would like to thank for helping me creating this program.


.topic 0x3EB
List of all tasks and partial information for each one (current status, current source file name, destination path and percentage progress). Click on an item in the list to view the task details in the controls on the right. You can manipulate the tasks in this list by using the buttons below.

.topic 0x3FA
Pauses the task selected in the task's list. If another task is waiting for the selected one to finish - it will start.

.topic 0x412
Restarts the task selected in the task's list. This will cause the task to run from the beginning.

.topic 0x3FE
Cancels the task selected in the task's list.

.topic 0x413
Removes the selected task from the task's list. If the task is running (not in the cancelled nor finished state) the program will ask if you want to finish the task.

.topic 0x414
Pauses all the tasks from the task's list.

.topic 0x3FD
Resumes work of the selected - paused task. Also if task is in wait state (waiting for another one to finish) this button causes it to start. When used on 'wait state' task it ignores configuration option 'Limit maximum operations running simultaneously'.

.topic 0x411
Starts all the tasks from the task's list.

.topic 0x416
Cancels all the tasks from the task's list.

.topic 0x417
Removes all the cancelled and finished tasks from the task's list.

.topic 0x415
Restarts all the tasks from the task's list.

.topic 0x462
Causes this dialog box to be repositioned to the right-bottom corner of the screen.

.topic 0x40E
Changes the view of this dialog from extended to simple and vice versa.

.topic 0x3F5
Changes the current buffer sizes for the currently selected task.

.topic 0x3F8
Changes priority of the currently selected task.

.topic 0x460
Shows .log file associated with the currently selected task.

.topic 0x410
Shows the file paths which describes the currently selected task. .atd and .atp files remembers the current state of the task. The .log file contains log information generated by the selected task.

.topic 0x405
Shows operation type and status of the currently selected task.

.topic 0x403
Shows current file path being processed by the selected task.

.topic 0x404
Shows destination path to which the selected task copies or moves the data.

.topic 0x409
Show the current progress statistics of the selected task.

.topic 0x40D
Shows the elapsed and estimated time the execution of the selected task would take.

.topic 0x40A
Shows the current and average transfer rate for the selected task.

.topic 0x406
Displays buffer size that is being used for copying current file to the destination location. Info is displayed for the currently selected task in the task's list. You can change it by the '...' button on the right.

.topic 0x407
Shows the priority at which the current task works. You can change it using the '>' button on the right.

.topic 0x40B
Shows progression information for all the tasks from the task's list.

.topic 0x40C
Shows current transfer rate for all the working tasks from the task's list.


.topic 1
Closes the window and stores the changed settings.

.topic 2
Closes this window and discards all changes.

.topic 0x4E9
Displays help information for this dialog box.

.topic 0x46E
Buffer size that would be used to copy or move data when 'Use only default buffer' checkbox is checked or any other buffer size cannot be applied.

.topic 0x46D
Specifies the size units in which the value on the left is specified.

.topic 0x46F
Buffer size that would be used to copy data between two places that lies on the same physical hard disk. The larger values in this buffer size could significantly improve copying performance. Too large values could lower the performance. One of the buffer sizes is chosen automatically unless the checkbox 'Use only default buffer' is checked.

.topic 0x472
Specifies the size units in which the value on the left is specified.

.topic 0x473
Buffer size that would be used to copy data between two different physical hard disks. This value shouldn't be too large because of possible performance degradation. One of the buffer sizes is chosen automatically unless the checkbox 'Use only default buffer' is checked.

.topic 0x474
Specifies the size units in which the value on the left is specified.

.topic 0x475
Buffer size that would be used to copy data from CD-ROM to any other storage medium. The value shouldn't be too large because the CD-ROM is rather slow device (comparing to a newer hard disks). One of the buffer sizes is chosen automatically unless the checkbox 'Use only default buffer' is checked.

.topic 0x476
Specifies the size units in which the value on the left is specified.

.topic 0x477
Buffer size that would be used to copy data from or to local network. The value should depend on the network performance - ie. on 10Mbps networks it should be lower than on 1Gbps networks. One of the buffer sizes is chosen automatically unless the checkbox 'Use only default buffer' is checked.

.topic 0x478
Specifies the size units in which the value on the left is specified.

.topic 0x479
Specifies if the task(s) should use only the default buffer size to copy/move data or should auto-detect the needed buffer size by analysing the source and destination storage medium.


.topic 1
Applies all the changes made in this dialog box and closes it.

.topic 2
Discards all the changes made in this dialog box.

.topic 0x4E9
Displays help information for this dialog box.

.topic 0x418
Shows the list of program's properties you can change.

.topic 0x4C2
Applies all changes made in this dialog box.


.topic 0x419
Shows the status of currently active tasks. The view depends on the options' set in the configuration dialog in section 'Miniview'.


.topic 1
Closes this window and starts a new task that would perform needed operation.

.topic 2
Closes this window and discards all changes you have made.

.topic 0x4E9
Displays help information for this dialog box.

.topic 0x429
Specifies the list of files and folders to be copied or moved to the destination folder. You can manage these items by the four buttons on the right.

.topic 0x3EA
Adds one or more files to the list of files/folders (on the left) to be copied or moved.

.topic 0x3F3
Adds a directory to the list of files/folders (on the left) to be copied or moved.

.topic 0x3EC
Removes files and/or folders from the list on the left.

.topic 0x4A7
Imports the files and folders paths from the text file. Each line of the text file must specify the path to the folder or file to be imported.

.topic 0x49B
Destination path - all the files and folders from the list above would be copied or moved to this location.

.topic 0x3F0
Opens the folder's choosing dialog in which you can specify the destination path.

.topic 0x3F1
Specifies operation that would be performed on the files and folders from the list.

.topic 0x42F
Specifies priority level at which the task would run. Use with caution when using very fast storage media - ie. ram disk or other memory-based device.

.topic 0x3F4
Specifies the buffer sizes that will be used by the task. You can change them by clicking on the button on the right.

.topic 0x400
Allows you to change the buffer sizes that will be used to perform the needed operation.

.topic 0x3F6
Enables or disables the filenames filtering for this task.

.topic 0x3F2
Specifies the list of active filters that will be used to perform the needed operation. You can add and remove them using the buttons on the right. Double-clicking the item allows you to edit selected filter.

.topic 0x401
Adds a new filter to the filter's list.

.topic 0x402
Removes the selected filter from the list.

.topic 0x3FF
Enables or disables the advanced options.

.topic 0x3F7
An advanced copy/move option. When selected it only copies the files to the destination location. So if you copy the 'c:\windows' folder to 'd:\' you will have all the files from 'c:\windows' and all of its subfolders in the root directory of drive 'd'.

.topic 0x3F9
An advanced copy/move option. If selected then does not copy the contents of the files. So if you copy the 700MB file you will have an empty file in the destination location. Be careful when you move data because you may lose all the data being copied.

.topic 0x3FC
An advanced copy/move option. If selected then creates the whole source path (relative to the root directory of the source disk drive) in the destination location. Ie. if you are copying the 'c:\windows\system' directory to 'd:\' you will get the 'd:\windows\system' directories in the destination location and the 'system' folder will contain the contents of the 'c:\windows\system'.


.topic 1
Replaces the path entered in the higher one of the edit boxes to the one from the edit box below and closes this dialog box.

.topic 2
Discards all changes and closes this dialog box.

.topic 0x4E9
Displays help information for this dialog box.

.topic 0x436
The list of the default paths that could be changed to something else. If any path is selected it will appear in the edit box below.

.topic 0x41A
Specifies the path that will be replaced with the one from the edit box below.

.topic 0x41B
Specifies path to which the one from above would be changed. You can enter the path manually or by the '...' button on the right.

.topic 0x428
Browses for a path that will be displayed in the window on the left.


.topic 2
Cancels the whole task.

.topic 0x44C
Retries the opening operation.

.topic 0x449
Ignores the error and skips copying the file.


.topic 2
Cancels the whole task.

.topic 0x4E6
Displays the info about an error. Contains the destination path in which there is not enough space.

.topic 0x429
Displays the list of files that are to be copied to the destination location.

.topic 0x467
Specifies required free space needed to copy the files.

.topic 0x468
Specifies available space in the destination location.

.topic 0x44C
Tries again to continue copying.

.topic 0x449
Ignores this error and continues copying.


.topic 2
Cancels the shutdown sequence and closes this dialog box.


.topic 1
Closes the window and saves the data.

.topic 2
Closes the window and discards the data.

.topic 0x4E9
Displays help information for this dialog box.

.topic 0x47E
Enables the inclusion mask filtering. The file names have to match one of these masks to be copied.

.topic 0x47D
Enter the needed inclusion masks here. If you want to enter more than one mask you should separate them by the '|' sign.

.topic 0x499
Enables the exclusion mask filtering. The file names must *not* match none of these masks to be copied.

.topic 0x498
Enter the needed exclusion masks here. If you want to enter more than one mask you should separate them by the '|' sign.

.topic 0x47F
Enables the file sizes filtering. The file to be copied must match the settings below to be copied.

.topic 0x482
Specifies the relation between size of the source file and the size specified on the right that needs to be meet for the file to be copied.

.topic 0x480
Specifies the size to which the source file size will be compared.

.topic 0x481
The multiplier for the value on the left.

.topic 0x488
Enables the second file sizes filtering. The file to be copied must match the settings above and on the right to be copied.

.topic 0x486
Specifies the second relation between size of the source file and the size specified on the right that needs to be met for the file to be copied.

.topic 0x484
Specifies the size to which the source file size will be compared.

.topic 0x485
The multiplier for the value on the left.

.topic 0x489
Enables filtering files by its' dates and times.

.topic 0x48F
Type of date/time that will be processed when comparing source file's date/time with the specified one.

.topic 0x490
Specifies the relation between date/time of the source file and the specified date and/or time that needs to be met for the file to be copied.

.topic 0x491
Specifies the date that will be compared to the source file's date. Needs to be met for the file to be copied. Used only if checked.

.topic 0x492
Specifies the time that will be compared to the source file's time. Needs to be met for the file to be copied. Used only if checked.

.topic 0x493
Enables filtering files by its' dates and times (second section).

.topic 0x494
Specifies the second relation between date/time of the source file and the specified date and/or time that needs to be met for the file to be copied.

.topic 0x495
Specifies the second date that will be compared to the source file's date. Needs to be met for the file to be copied. Used only if checked.

.topic 0x496
Specifies the second time that will be compared to the source file's time. Needs to be met for the file to be copied. Used only if checked.

.topic 0x48A
Enables filterinf files by their attributes.

.topic 0x48B
Allows filtering by the 'Archive' attribute. If unchecked - the attribute must not be set for a file to be copied, if checked - must be set and if grayed - it does not matter.

.topic 0x48C
Allows filtering by the 'Read only' attribute. If unchecked - the attribute must not be set for a file to be copied, if checked - must be set and if grayed - it does not matter.

.topic 0x48D
Allows filtering by the 'Hidden' attribute. If unchecked - the attribute must not be set for a file to be copied, if checked - must be set and if grayed - it does not matter.

.topic 0x48E
Allows filtering by the 'System' attribute. If unchecked - the attribute must not be set for a file to be copied, if checked - must be set and if grayed - it does not matter.

.topic 0x497
Allows filtering by the 'Directory' attribute. If unchecked - the attribute must not be set for a file to be copied, if checked - must be set and if grayed - it does not matter.


.topic 1
Saves all the changes made in this dialog box and closes it.

.topic 2
Discards all changes made in this dialog box.

.topic 0x4E9
Displays help information for this dialog box.

.topic 0x49C
List of currently defined shortcuts. You can edit them by using the elements below.

.topic 0x4A8
Moves the selected shortcut(s) up by one position.

.topic 0x4A9
Moves the selected shortcut(s) down by one position.

.topic 0x49D
Specifies name of the shortcut.

.topic 0x49E
Specifies path of the shortcut. You can enter the path manually or by using the '...' button on the right.

.topic 0x428
Browses for a path that will be displayed in the window on the left.

.topic 0x424
Adds the shortcut defined by the edit and combo box above to the shortcut's list.

.topic 0x4A1
Changes the selected shortcut in the list with the one defined by the edit and combo box above.

.topic 0x413
Deletes selected shortcut from the list.


.topic 1
Exits this dialog box and saves the changes.

.topic 2
Exit this dialog box without saving the changes.

.topic 0x4E9
Displays help information for this dialog box.

.topic 0x4A6
The list of recently used paths. You can manage them by the elements below.

.topic 0x41F
Displays path either at the list's current selection or a new one - specifies by user. May be changed manually by entering the path from keyboard or by the '...' button on the right.

.topic 0x428
Browses for a path that will be displayed in the window on the left.

.topic 0x424
Adds the entered path into the list.

.topic 0x4A1
Replaces the list's current selection with an entered path.

.topic 0x413
Deletes current selection from the list.